root = this


# Define the scope for our SDK and bundle in some
# configuration. We aim to encapsulate everything
# except this root object.
root.Deckchair =
  ready: false
#  environment: 'development'
#  debug: true
  environment: 'production'
  debug: false

  Libraries:
    $: null
    jQuery: null
    Underscore: null
    Backbone: null

  Scratchpad: {}
  Configuration:
    api:
      version: 'v1'
    base_domain:
      production:
        www: 'www.deckchair.com'
        api: 'api.deckchair.com'
        images: 'images.deckchair.com'
      development:
        www: '0.0.0.0:3000'
        api: '0.0.0.0:9000'
        images: '0.0.0.0:9000'
    widget:
      selector: '[data-deckchair-widget]'
      options:
        width: 640
        height: 480
        resize_mode: 'fill'

  Models: {}
  Collections: {}
  Views: {}
  Instances:
    Models: {}
    Collections: {}
    Views: {}



## Put libraries into noConflict mode and attach them to the Deckchair NS.

# jQuery is dealt with later in the script execution (see closure.coffee)
# JSON2.js cannot be encapsulated as it needs to extend core JS classes like Date()
# to add a to_json method.
#
# json2.js has minimal conflicting libraries and JSON support is available in most modern
# browsers so the library is likely unused by most visitors.
root.Deckchair.Libraries.Backbone = root.Backbone.noConflict()
_ = root.Deckchair.Libraries.Underscore = root._.noConflict()



# Override the call to BackboneSync and attach jsonp as the datatype to the options array.
# Once added, we call the original BackboneSync function with the new options.
root.Deckchair.Scratchpad.originalBackboneSync = root.Deckchair.Libraries.Backbone.sync
root.Deckchair.Libraries.Backbone.sync = (method, model, options) ->
  options = _.extend options,
    dataType: 'jsonp'
  root.Deckchair.Scratchpad.originalBackboneSync.apply(root.Deckchair.Libraries.Backbone, [method, model, options])



# Add Backbone custom method. Returns where the item is (index) within it's containing
# collection. It does iterate so no magic here...
root.Deckchair.Libraries.Backbone.Model.prototype.indexInCollection = () ->
  if @collection
    _cids = @collection.map (_model) ->
      _model.cid
    return _(_cids).indexOf(@cid)
