#  id: 9,
#  title: "Swiss Mountains",
#  description: "",
#  location: { ... },
#  active: true,
#  minimum_interval: 15,
#  ad_title: "Swiss Mountain Camera",
#  ad_caption: "http://kirchbuehl.ch",
#  importer: { ... }

root = exports ? this

class root.Deckchair.Models.Camera extends root.Deckchair.Libraries.Backbone.AssociatedModel
  idAttribute: 'id'


  relations: [
    {
      type: root.Deckchair.Libraries.Backbone.Many
      key: 'images'
      relatedModel: 'root.Deckchair.Models.Image'
      collectionType: 'root.Deckchair.Collections.Images'
    }
    {
      type: root.Deckchair.Libraries.Backbone.One
      key: 'location'
      relatedModel: 'root.Deckchair.Models.Location'
    }
    {
      type: root.Deckchair.Libraries.Backbone.One
      key: 'importer'
      relatedModel: 'root.Deckchair.Models.Importer'
    }
  ]


  defaults:
    id: null
    title: null
    description: null

    active: null
    minimum_interval: null

    ad_title: null
    ad_caption: null

    location: null
    importer: null
    images: []


  urlRoot: "http://#{ root.Deckchair.Configuration.base_domain[ root.Deckchair.environment ].api }/#{ root.Deckchair.Configuration.api.version }/cameras"
  url: ->
    "#{ @urlRoot }/#{ @get('id') }"