#  id: 11084,
#  taken: "2013-03-04T16:10:59+00:00",
#  location: {...}

root = exports ? this

class root.Deckchair.Models.Image extends root.Deckchair.Libraries.Backbone.AssociatedModel
  idAttribute: 'id'


  relations: [
    {
      type: root.Deckchair.Libraries.Backbone.One
      key: 'location'
      relatedModel: 'root.Deckchair.Models.Location'
    }
  ]


  initialize: ->
    unless _.isDate @get('taken')
      @set 'taken', new Date( Date.parse( @get('taken') ) )


  defaults:
    id: null
    taken: null
    camera_id: null
    location_id: null
    is_first: null
    is_last: null


  urlRoot: "http://#{ root.Deckchair.Configuration.base_domain[ root.Deckchair.environment ].images }/image"
  getImageUrl: (options={}) ->
    "#{ @urlRoot }/#{ @get('id') }?#{ $.param( options ) }"


  parse: (response) ->
    if _.isObject(response.result)
      response = response.result

    if response.taken
      response.taken = new Date( response.taken )
    return response


  getNext: () ->
    unless @get('is_last')
      curr_index = @indexInCollection()
      next_image = @collection.at( curr_index-1 )
      return next_image if next_image
    return false


  getPrev: () ->
    unless @get('is_first')
      curr_index = @indexInCollection()
      prev_image = @collection.at( curr_index+1 )
      return prev_image if prev_image
    return false
