#  type: "ImporterPanomax",
#  description: "Import from Panomax/Roundshot",
#  interval: 900,
#  in_progress: false,
#  last_attempt: "2013-03-04T16:42:47+00:00",
#  last_update: "2013-03-04T16:11:05+00:00"

root = exports ? this

class root.Deckchair.Models.Importer extends root.Deckchair.Libraries.Backbone.Model
  idAttribute: 'id'

  initialize: ->
    unless _.isDate @get('last_attempt')
      @set 'last_attempt', new Date( Date.parse( @get('last_attempt') ) )

    unless _.isDate @get('last_update')
      @set 'last_update', new Date( Date.parse( @get('last_update') ) )


  defaults:
    type: null
    description: null
    interval: null
    in_progress: null
    last_attempt: null
    last_update: null


  parse: (response) ->
    if _.isObject(response.result)
      response = response.result

    if response.last_update
      response.last_update = new Date( Date.parse( response.last_update ) )

    if response.last_attempt
      response.last_attempt = new Date( Date.parse( response.last_attempt ) )

    return response